/* Zadatak 1A:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija iz (a). */

int parznam(int x, int b, int *p_uk_znam)
{
    int uk_znam = 0, par_znam = 0, znam;

        /* Apsolutna vrijednost od x. */
    if (x < 0) x = -x;

        /* Brojanje trazenih i svih znamenki. */
    while (x > 0) {
        znam = x % b;
        x /= b;
        ++uk_znam;
        if (znam % 2 == 0) ++par_znam;
    }

        /* Izlaz kroz varijabilni argument. */
    *p_uk_znam = uk_znam;

    return par_znam;
}

/* ========================================================================= */

    /* Glavni program iz (b). */

int main(void)
{
    int x, baza, par_znam, uk_znam;
    int b, max_par = -1, min_uk = 0;

        /* Kozmetika za rucno upisivanje brojeva. */
    printf(" Upisi cijeli broj x:\n");
    scanf("%d", &x);

        /* Provjera ulaznog broja i poruka. */
    if (x < 3) {
        printf(" Nema trazene baze (x < 3).");
        return 0;
    }

        /* Petlja za baze, 3 <= baza <= x.
           Petlja je uzlazna, tj. baza raste.
           Kad pamtimo bazu, onda pamtimo prvu = najmanju. */
    for (baza = 3; baza <= x; ++baza) {

            /* Poziv funkcije iz (a). */
        par_znam = parznam(x, baza, &uk_znam);

            /* Provjera rezultata za ovu bazu. */
        if (par_znam > max_par) {
            b = baza;
            max_par = par_znam;
            min_uk = uk_znam;
        }
        else if (par_znam == max_par) {
            if (uk_znam < min_uk) {
                b = baza;
                min_uk = uk_znam;
            }
                /* Ne treba provjera za uk_znam == min_uk,
                   jer baza raste, pa pamtimo najmanji b. */
        }

            /* Kontrolni ispis. */
        printf("  x = %5d, baza = %5d, parne = %2d, ukupno = %3d\n",
               x, baza, par_znam, uk_znam);

    }

        /* Ispis trazene baze. */
    printf(" Trazena baza = %d\n", b);

    return 0;
}
