/* Zadatak 1C:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija iz (a). */

int neparznam(int x, int b, int *p_nep_znam)
{
    int uk_znam = 0, nep_znam = 0, znam;

        /* Apsolutna vrijednost od x. */
    if (x < 0) x = -x;

        /* Brojanje trazenih i svih znamenki. */
    while (x > 0) {
        znam = x % b;
        x /= b;
        ++uk_znam;
        if (znam % 2 == 1) ++nep_znam;
    }

        /* Izlaz kroz varijabilni argument. */
    *p_nep_znam = nep_znam;

    return uk_znam;
}

/* ========================================================================= */

    /* Glavni program iz (b). */

int main(void)
{
    int x, baza, nep_znam, uk_znam;
    int b, max_uk = 0;

        /* Kozmetika za rucno upisivanje brojeva. */
    printf(" Upisi cijeli broj x:\n");
    scanf("%d", &x);

        /* Provjera ulaznog broja i poruka. */
    if (x < 3) {
        printf(" Nema trazene baze (x < 3).");
        return 0;
    }

        /* Petlja za baze, x >= baza >= 3.
           Petlja je silazna, tj. baza pada.
           Kad pamtimo bazu, onda pamtimo prvu = najvecu. */
    for (baza = x; baza >= 3; --baza) {

            /* Poziv funkcije iz (a). */
        uk_znam = neparznam(x, baza, &nep_znam);

            /* Provjera rezultata za ovu bazu. */
        if (nep_znam == uk_znam) {
            if (max_uk == 0 || uk_znam > max_uk) {
                b = baza;
                max_uk = uk_znam;
            }
                /* Ne treba provjera za uk_znam == max_uk,
                   jer baza pada, pa pamtimo najveci b. */
        }

            /* Kontrolni ispis. */
        printf("  x = %5d, baza = %5d, neparne = %2d, ukupno = %3d\n",
               x, baza, nep_znam, uk_znam);

    }

        /* Ispis trazene baze. */
    if (max_uk > 0)
        printf(" Trazena baza = %d\n", b);
    else
        printf(" Nema trazene baze.");

    return 0;
}
