/* Zadatak 1D:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija iz (a). */

int nulznam(int x, int b, int *p_nul_znam)
{
    int uk_znam = 0, nul_znam = 0, znam;

        /* Apsolutna vrijednost od x. */
    if (x < 0) x = -x;

        /* Brojanje trazenih i svih znamenki. */
    while (x > 0) {
        znam = x % b;
        x /= b;
        ++uk_znam;
        if (znam == 0) ++nul_znam;
    }

        /* Izlaz kroz varijabilni argument. */
    *p_nul_znam = nul_znam;

    return uk_znam;
}

/* ========================================================================= */

    /* Glavni program iz (b). */

int main(void)
{
    int x, baza, nul_znam, uk_znam;
    int b, min_nul = -1, max_uk = 0;

        /* Kozmetika za rucno upisivanje brojeva. */
    printf(" Upisi cijeli broj x:\n");
    scanf("%d", &x);

        /* Provjera ulaznog broja i poruka. */
    if (x < 3) {
        printf(" Nema trazene baze (x < 3).");
        return 0;
    }

        /* Petlja za baze, x >= baza >= 3.
           Petlja je silazna, tj. baza pada.
           Kad pamtimo bazu, onda pamtimo prvu = najvecu. */
    for (baza = x; baza >= 3; --baza) {

            /* Poziv funkcije iz (a). */
        uk_znam = nulznam(x, baza, &nul_znam);

            /* Provjera rezultata za ovu bazu. */
        if (min_nul < 0 || nul_znam < min_nul) {
            b = baza;
            min_nul = nul_znam;
            max_uk = uk_znam;
        }
        else if (nul_znam == min_nul) {
            if (uk_znam > max_uk) {
                b = baza;
                max_uk = uk_znam;
            }
                /* Ne treba provjera za uk_znam == max_uk,
                   jer baza pada, pa pamtimo najveci b. */
        }

            /* Kontrolni ispis. */
        printf("  x = %5d, baza = %5d, nule = %2d, ukupno = %3d\n",
               x, baza, nul_znam, uk_znam);

    }

        /* Ispis trazene baze. */
    printf(" Trazena baza = %d\n", b);

    return 0;
}
