/* Zadatak 4C:

*/

#include <stdio.h>

int isprime(int n) {
    int i;
    for (i = 2; i*i <= n; i++)
        if (n%i == 0) return 0;
    return 1;
}

int hasdigits(int n) {
    int z;
    while (n > 0) {
        z = n%10;
        if (z == 3 || z == 4 || z == 7) return 1;
        n /= 10;
    }
    return 0;
}

int first(int n) {
    while (n >= 10) n /= 10;
    return n;
}

void sort(int n, int x[]) {
    int i, j, temp;
    for (i = 0; i < n-1; i++)
        for (j = i+1; j < n; j++)
            if (first(x[i]) > first(x[j])) {
                temp = x[i];
                x[i] = x[j];
                x[j] = temp;
            }
}

int delsort(int n, int x[]) {
    int i, j;
    for (i = n-1; i >= 0; i--)
        if(isprime(x[i]) && hasdigits(x[i])) {
            n--;
            for (j = i; j < n; j++)
                x[j] = x[j+1];
        }
    sort(n, x);
    return n;
}

void print(int n, int x[]) {
    int i;
    for (i = 0; i < n; i++)
        printf(" %d", x[i]);
    printf("\n");
}

    /* Glavni program za demo. */
int main(void) {
    int n = 10;
    int x[10] = {
      13, 12, 23, 41, 58, 74, 39, 45, 19, 17 };

    printf("Pocetno polje, n = %d elemenata:\n", n);
    print(n, x);

    n = delsort(n, x);
    printf("Polje nakon delsort, n = %d elemenata:\n", n);
    print(n, x);

    return 0;
}
