/* Zadatak 1B:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija iz (a). */

int bznam(int x, int b, int *p_uk_znam)
{
    int uk_znam = 0, bm1_znam = 0, znam;
    int bm1 = b - 1;

        /* Apsolutna vrijednost od x. */
    if (x < 0) x = -x;

        /* Brojanje trazenih i svih znamenki. */
    while (x > 0) {
        znam = x % b;
        x /= b;
        ++uk_znam;
        if (znam == bm1) ++bm1_znam;
    }

        /* Izlaz kroz varijabilni argument. */
    *p_uk_znam = uk_znam;

    return bm1_znam;
}

/* ========================================================================= */

    /* Glavni program iz (b). */

int main(void)
{
    int x, baza, bm1_znam, uk_znam;
    int b, min_uk = 0;

        /* Kozmetika za rucno upisivanje brojeva. */
    printf(" Upisi cijeli broj x:\n");
    scanf("%d", &x);

        /* Provjera ulaznog broja i poruka. */
    if (x < 3) {+
        printf(" Nema trazene baze (x < 3).");
        return 0;
    }

        /* Petlja za baze, 3 <= baza <= x.
           Petlja je uzlazna, tj. baza raste.
           Kad pamtimo bazu, onda pamtimo prvu = najmanju. */
    for (baza = 3; baza <= x; ++baza) {

            /* Poziv funkcije iz (a). */
        bm1_znam = bznam(x, baza, &uk_znam);

            /* Provjera rezultata za ovu bazu. */
        if (bm1_znam > 0) {
            if (min_uk == 0 || uk_znam < min_uk) {
                b = baza;
                min_uk = uk_znam;
            }
                /* Ne treba provjera za uk_znam == min_uk,
                   jer baza raste, pa pamtimo najmanji b. */
        }

            /* Kontrolni ispis. */
        printf("  x = %5d, baza = %5d, bm1 = %2d, ukupno = %3d\n",
               x, baza, bm1_znam, uk_znam);

    }

        /* Ispis trazene baze. */
    if (min_uk > 0)
        printf(" Trazena baza = %d\n", b);
    else
        printf(" Nema trazene baze.");

    return 0;
}
